##
##  ngtcp2.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2024 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_base 1.10.0
%define       V_snap 20241219

#   package information
Name:         ngtcp2
Summary:      QUIC Library
URL:          https://github.com/ngtcp2/ngtcp2
Vendor:       ngtcp2 Contributors
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Networking
License:      MIT
Version:      %{V_base}
Release:      20241219

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/ngtcp2/ngtcp2-%{V_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, gcc, gcc::with_cxx = yes, cmake
PreReq:       OpenPKG, openpkg >= 20160101

%description
    ngtcp2 is an implementation of QUIC in C. This library implements
    the QUIC standard from RFC9000.

%track
    prog ngtcp2 = {
        version   = %{V_base}
        url       = https://github.com/ngtcp2/ngtcp2/releases
        regex     = tree/v(__VER__)
    }

%prep
    %setup -q -n ngtcp2

%build
    mkdir build
    cd build
    cmake \
        -Wno-dev \
        -DCMAKE_BUILD_TYPE="Release" \
        -DCMAKE_INSTALL_PREFIX="%{l_prefix}" \
        -DCMAKE_C_COMPILER="%{l_cc}" \
        -DCMAKE_C_FLAGS="%{l_cflags} %{l_cppflags}" \
        -DCMAKE_EXE_LINKER_FLAGS="%{l_ldflags}" \
        -DCMAKE_CXX_COMPILER="%{l_cxx}" \
        -DENABLE_SHARED_LIB=OFF \
        -DBUILD_TESTING=OFF \
        -DENABLE_OPENSSL=OFF \
        ..
    %{l_make} %{l_mflags -O}

%install
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/lib/pkgconfig \
        $RPM_BUILD_ROOT%{l_prefix}/include/ngtcp2
    %{l_shtool} install -c -m 644 \
        build/lib/libngtcp2.a $RPM_BUILD_ROOT%{l_prefix}/lib/
    %{l_shtool} install -c -m 644 \
        build/lib/libngtcp2.pc $RPM_BUILD_ROOT%{l_prefix}/lib/pkgconfig/
    %{l_shtool} install -c -m 644 \
        lib/includes/ngtcp2/ngtcp2.h \
        build/lib/includes/ngtcp2/version.h \
        $RPM_BUILD_ROOT%{l_prefix}/include/ngtcp2/
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

